import { Size } from "../datatypes.ts";

// TODO: Just switch to the same pattern as everywhere else
// (without repeatedly reassigning the variable)
class Screen {
  #canvas: HTMLCanvasElement;
  size: Size;

  constructor(canvas: HTMLCanvasElement, size: Size) {
    this.#canvas = canvas;
    this.size = size;
  }

  unsafeMakeContext(): CanvasRenderingContext2D {
    let ctx = this.#canvas.getContext("2d")!;

    // TODO: Other stuff to do here?
    ctx.globalCompositeOperation = "source-over";
    ctx.filter = "none";
    ctx.strokeStyle = "#000";
    ctx.fillStyle = "#000";
    ctx.resetTransform();
    ctx.imageSmoothingEnabled = false;

    return ctx;
  }
}

let active: Screen | undefined = undefined;

// TODO: Move these to Game?
export let desiredWidth = 400;
export let desiredHeight = 400;

export function pollAndTouch(canvas: HTMLCanvasElement) {
  let realWidth = canvas.offsetWidth;
  let realHeight = canvas.offsetHeight;

  let divisors = [0.25, 0.5, 1, 2, 3, 4, 5, 6];
  for (let i = 0; i < divisors.length; i++) {
    // TODO: Is this necessary?
    divisors[i] /= window.devicePixelRatio;
  }

  let div = 0;
  while (
    div < divisors.length - 1 &&
    realWidth / divisors[div + 1] >= desiredWidth &&
    realHeight / divisors[div + 1] >= desiredHeight
  ) {
    div += 1;
  }
  realWidth = Math.floor(canvas.offsetWidth / divisors[div]);
  realHeight = Math.floor(canvas.offsetHeight / divisors[div]);
  canvas.width = realWidth;
  canvas.height = realHeight;
  active = new Screen(canvas, new Size(realWidth, realHeight));
}

export function getScreen(): Screen {
  if (active === undefined) {
    throw `screen should have been defined: ${active}`;
  }
  return active;
}
